/*
	Little Smalltalk, version 3
	Written by Tim Budd, Oregon State University, July 1988

	Symantec Think Class Library interface code Julian Barkway, April 1994 

	CLStApp.h
	---------
	
	Application related functions
*/

#pragma once
#include "CApplication.h"

struct CLStApp : CApplication {
public:
	EventRecord		lastEvent;			/* Hold on to current event */
	short			menuID, menuItem;		// Normally the selected menu and menu item
											// but if 'Quit' is selected in the 'File'
											// menu, menuID will contain 0xFFFF.
	Boolean			smalltalkCmd;		/* Differentiate between TCL Cmds and ours */
	short			winPart;

	SFReply			theFile;			// The file to open on receiving an 
										// 'open document' event (NULL if event not
										// present).
										
	Str255 			versionStr;			// The current version string - as obtained 
										// from the 'vers' resource.
	
	void	ILStApp				(void);
	void	SetUpFileParameters	(void);
	void	DoCommand			(long commandNo);
	Boolean	Quit				(void);
	void	MakeSwitchboard		(void);
	void	DoMessageAlert		(char *msg);
	short 	DoYNCAlert			(char *msg);
	void	DoAbout				(long delay);

	void	OpenDocument		(SFReply *macSFReply);
};
